diff -urN ../VisualBoyAdvance-1.7.2/src/thumb.h ./src/thumb.h
--- ../VisualBoyAdvance-1.7.2/src/thumb.h	2004-05-13 22:50:06 +0900
+++ ./src/thumb.h	2006-06-25 05:21:47 +0900
@@ -1950,297 +1864,67 @@
     CPUWriteMemory(address, reg[(r)].I);\
     if(!offset) {\
       reg[(b)].I = temp;\
-      clockTicks += 1 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
     } else \
-      clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     offset = 1;\
     address += 4;\
   }
  case 0xc0:
-   {
-     // STM R0!, {Rlist}
-     u32 address = reg[0].I & 0xFFFFFFFC;
-     u32 temp = reg[0].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 0);
-     THUMB_STM_REG(2, 1, 0);
-     THUMB_STM_REG(4, 2, 0);
-     THUMB_STM_REG(8, 3, 0);
-     THUMB_STM_REG(16, 4, 0);
-     THUMB_STM_REG(32, 5, 0);
-     THUMB_STM_REG(64, 6, 0);
-     THUMB_STM_REG(128, 7, 0);
-   }
-   break;   
  case 0xc1:
-   {
-     // STM R1!, {Rlist}
-     u32 address = reg[1].I & 0xFFFFFFFC;
-     u32 temp = reg[1].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 1);
-     THUMB_STM_REG(2, 1, 1);
-     THUMB_STM_REG(4, 2, 1);
-     THUMB_STM_REG(8, 3, 1);
-     THUMB_STM_REG(16, 4, 1);
-     THUMB_STM_REG(32, 5, 1);
-     THUMB_STM_REG(64, 6, 1);
-     THUMB_STM_REG(128, 7, 1);
-   }
-   break;      
  case 0xc2:
-   {
-     // STM R2!, {Rlist}
-     u32 address = reg[2].I & 0xFFFFFFFC;
-     u32 temp = reg[2].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 2);
-     THUMB_STM_REG(2, 1, 2);
-     THUMB_STM_REG(4, 2, 2);
-     THUMB_STM_REG(8, 3, 2);
-     THUMB_STM_REG(16, 4, 2);
-     THUMB_STM_REG(32, 5, 2);
-     THUMB_STM_REG(64, 6, 2);
-     THUMB_STM_REG(128, 7, 2);
-   }
-   break;      
  case 0xc3:
-   {
-     // STM R3!, {Rlist}
-     u32 address = reg[3].I & 0xFFFFFFFC;
-     u32 temp = reg[3].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 3);
-     THUMB_STM_REG(2, 1, 3);
-     THUMB_STM_REG(4, 2, 3);
-     THUMB_STM_REG(8, 3, 3);
-     THUMB_STM_REG(16, 4, 3);
-     THUMB_STM_REG(32, 5, 3);
-     THUMB_STM_REG(64, 6, 3);
-     THUMB_STM_REG(128, 7, 3);
-   }
-   break;   
  case 0xc4:
-   {
-     // STM R4!, {Rlist}
-     u32 address = reg[4].I & 0xFFFFFFFC;
-     u32 temp = reg[4].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 4);
-     THUMB_STM_REG(2, 1, 4);
-     THUMB_STM_REG(4, 2, 4);
-     THUMB_STM_REG(8, 3, 4);
-     THUMB_STM_REG(16, 4, 4);
-     THUMB_STM_REG(32, 5, 4);
-     THUMB_STM_REG(64, 6, 4);
-     THUMB_STM_REG(128, 7, 4);
-   }
-   break;   
  case 0xc5:
-   {
-     // STM R5!, {Rlist}
-     u32 address = reg[5].I & 0xFFFFFFFC;
-     u32 temp = reg[5].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 5);
-     THUMB_STM_REG(2, 1, 5);
-     THUMB_STM_REG(4, 2, 5);
-     THUMB_STM_REG(8, 3, 5);
-     THUMB_STM_REG(16, 4, 5);
-     THUMB_STM_REG(32, 5, 5);
-     THUMB_STM_REG(64, 6, 5);
-     THUMB_STM_REG(128, 7, 5);
-   }
-   break;   
  case 0xc6:
-   {
-     // STM R6!, {Rlist}
-     u32 address = reg[6].I & 0xFFFFFFFC;
-     u32 temp = reg[6].I + 4*cpuBitsSet[opcode & 0xff];
-     int offset = 0;
-     // store
-     THUMB_STM_REG(1, 0, 6);
-     THUMB_STM_REG(2, 1, 6);
-     THUMB_STM_REG(4, 2, 6);
-     THUMB_STM_REG(8, 3, 6);
-     THUMB_STM_REG(16, 4, 6);
-     THUMB_STM_REG(32, 5, 6);
-     THUMB_STM_REG(64, 6, 6);
-     THUMB_STM_REG(128, 7, 6);
-   }
-   break;   
  case 0xc7:
    {
-     // STM R7!, {Rlist}
-     u32 address = reg[7].I & 0xFFFFFFFC;
-     u32 temp = reg[7].I + 4*cpuBitsSet[opcode & 0xff];
+     // STM R0~7!, {Rlist}
+     u8 regist = (opcode >> 8) & 7;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
+     u32 address = reg[regist].I & 0xFFFFFFFC;
+     u32 temp = reg[regist].I + 4*cpuBitsSet[opcode & 0xff];
      int offset = 0;
      // store
-     THUMB_STM_REG(1, 0, 7);
-     THUMB_STM_REG(2, 1, 7);
-     THUMB_STM_REG(4, 2, 7);
-     THUMB_STM_REG(8, 3, 7);
-     THUMB_STM_REG(16, 4, 7);
-     THUMB_STM_REG(32, 5, 7);
-     THUMB_STM_REG(64, 6, 7);
-     THUMB_STM_REG(128, 7, 7);
+     THUMB_STM_REG(1, 0, regist);
+     THUMB_STM_REG(2, 1, regist);
+     THUMB_STM_REG(4, 2, regist);
+     THUMB_STM_REG(8, 3, regist);
+     THUMB_STM_REG(16, 4, regist);
+     THUMB_STM_REG(32, 5, regist);
+     THUMB_STM_REG(64, 6, regist);
+     THUMB_STM_REG(128, 7, regist);
+     clockTicks = codeTicksAccess16(armNextPC)+1;
    }
-   break;
+   break;   
 #define THUMB_LDM_REG(val,r) \
   if(opcode & (val)) {\
     reg[(r)].I = CPUReadMemory(address);\
     if(offset)\
-      clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);\
-    else\
-      clockTicks += 2 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
+    else \
+      clockTicks += 1 + dataTicksAccess32(address);\
     offset = 1;\
     address += 4;\
   }
  case 0xc8:
-   {
-     // LDM R0!, {Rlist}
-     u32 address = reg[0].I & 0xFFFFFFFC;
-     u32 temp = reg[0].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);
-     if(!(opcode & 1))
-       reg[0].I = temp;
-   }
-   break;
  case 0xc9:
-   {
-     // LDM R1!, {Rlist}
-     u32 address = reg[1].I & 0xFFFFFFFC;
-     u32 temp = reg[1].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);
-     if(!(opcode & 2))
-       reg[1].I = temp;
-   }
-   break;
  case 0xca:
-   {
-     // LDM R2!, {Rlist}
-     u32 address = reg[2].I & 0xFFFFFFFC;
-     u32 temp = reg[2].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);
-     if(!(opcode & 4))
-       reg[2].I = temp;
-   }
-   break;
  case 0xcb:
-   {
-     // LDM R3!, {Rlist}
-     u32 address = reg[3].I & 0xFFFFFFFC;
-     u32 temp = reg[3].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);
-     if(!(opcode & 8))
-       reg[3].I = temp;
-   }
-   break;
  case 0xcc:
-   {
-     // LDM R4!, {Rlist}
-     u32 address = reg[4].I & 0xFFFFFFFC;
-     u32 temp = reg[4].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);   
-     if(!(opcode & 16))
-       reg[4].I = temp;
-   }
-   break;
  case 0xcd:
-   {
-     // LDM R5!, {Rlist}
-     u32 address = reg[5].I & 0xFFFFFFFC;
-     u32 temp = reg[5].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);   
-     if(!(opcode & 32))
-       reg[5].I = temp;
-   }
-   break;
  case 0xce:
-   {
-     // LDM R6!, {Rlist}
-     u32 address = reg[6].I & 0xFFFFFFFC;
-     u32 temp = reg[6].I + 4*cpuBitsSet[opcode & 0xFF];
-     int offset = 0;
-     // load
-     THUMB_LDM_REG(1, 0);
-     THUMB_LDM_REG(2, 1);
-     THUMB_LDM_REG(4, 2);
-     THUMB_LDM_REG(8, 3);
-     THUMB_LDM_REG(16, 4);
-     THUMB_LDM_REG(32, 5);
-     THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);   
-     if(!(opcode & 64))
-       reg[6].I = temp;
-   }
-   break;
  case 0xcf:
    {
-     // LDM R7!, {Rlist}
-     u32 address = reg[7].I & 0xFFFFFFFC;
-     u32 temp = reg[7].I + 4*cpuBitsSet[opcode & 0xFF];
+     // LDM R0~R7!, {Rlist}
+     u8 regist = (opcode >> 8) & 7;
+     if (!busPrefetchCount)
+       busPrefetch = busPrefetchEnable;
+     u32 address = reg[regist].I & 0xFFFFFFFC;
+     u32 temp = reg[regist].I + 4*cpuBitsSet[opcode & 0xFF];
      int offset = 0;
+     clockTicks = 0;
      // load
      THUMB_LDM_REG(1, 0);
      THUMB_LDM_REG(2, 1);
@@ -2249,141 +1933,232 @@
      THUMB_LDM_REG(16, 4);
      THUMB_LDM_REG(32, 5);
      THUMB_LDM_REG(64, 6);
-     THUMB_LDM_REG(128, 7);   
-     if(!(opcode & 128))
-       reg[7].I = temp;
+     THUMB_LDM_REG(128, 7);
+     clockTicks += codeTicksAccess16(armNextPC)+2;
+     if(!(opcode & (1<<regist)))
+       reg[regist].I = temp;
    }
    break;
  case 0xd0:
    // BEQ offset
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
    if(Z_FLAG) {
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;      
  case 0xd1:
    // BNE offset
    if(!Z_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd2:
    // BCS offset
    if(C_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd3:
    // BCC offset
    if(!C_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd4:
    // BMI offset
    if(N_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd5:
    // BPL offset
    if(!N_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd6:
    // BVS offset
    if(V_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd7:
    // BVC offset
    if(!V_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd8:
    // BHI offset
    if(C_FLAG && !Z_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xd9:
    // BLS offset
    if(!C_FLAG || Z_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xda:
    // BGE offset
    if(N_FLAG == V_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xdb:
    // BLT offset
    if(N_FLAG != V_FLAG) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xdc:
    // BGT offset
    if(!Z_FLAG && (N_FLAG == V_FLAG)) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xdd:
    // BLE offset
    if(Z_FLAG || (N_FLAG != V_FLAG)) {
+#ifdef BKPT_SUPPORT
+		 UPDATE_OLD_REG
+#endif
      reg[15].I += ((s8)(opcode & 0xFF)) << 1;       
      armNextPC = reg[15].I;
      reg[15].I += 2;
-     clockTicks = 3;       
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC)+3;
+     busPrefetchCount=0;
    }
    break;   
  case 0xdf:
+     {
    // SWI #comment
+   u32 address = 0;
+   clockTicks = codeTicksAccessSeq16(address) + codeTicksAccessSeq16(address) +
+       codeTicksAccess16(address)+3;
+   busPrefetchCount=0;
    CPUSoftwareInterrupt(opcode & 0xFF);
    break;
+     }
  case 0xe0:
  case 0xe1:
  case 0xe2:
@@ -2400,6 +2175,10 @@
      reg[15].I += offset;
      armNextPC = reg[15].I;
      reg[15].I += 2;
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) + codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC) + 3;
+     busPrefetchCount=0;
    }
    break;
  case 0xf0:
@@ -2410,6 +2189,7 @@
      // BLL #offset
      int offset = (opcode & 0x7FF);
      reg[14].I = reg[15].I + (offset << 12);
+     clockTicks = codeTicksAccessSeq16(armNextPC) + 1;
    }
    break;      
  case 0xf4:
@@ -2420,6 +2200,7 @@
      // BLL #offset
      int offset = (opcode & 0x7FF);
      reg[14].I = reg[15].I + ((offset << 12) | 0xFF800000);
+     clockTicks = codeTicksAccessSeq16(armNextPC) + 1;
    }
    break;   
  case 0xf8:
@@ -2438,6 +2219,10 @@
      armNextPC = reg[15].I;
      reg[15].I += 2;
      reg[14].I = temp|1;
+     THUMB_PREFETCH;
+     clockTicks = codeTicksAccessSeq16(armNextPC) +
+         codeTicksAccess16(armNextPC) + codeTicksAccessSeq16(armNextPC) + 3;
+     busPrefetchCount = 0;
    }
    break;
 #ifdef BKPT_SUPPORT
@@ -2472,3 +2257,6 @@
    CPUUndefinedException();
    break;
 }
+
+if (clockTicks==0)
+clockTicks = codeTicksAccessSeq16(oldArmNextPC) + 1;
diff -urN ../VisualBoyAdvance-1.7.2/src/unzip.cpp ./src/unzip.cpp
--- ../VisualBoyAdvance-1.7.2/src/unzip.cpp	2004-05-13 23:32:15 +0900
+++ ./src/unzip.cpp	2006-05-27 23:47:32 +0900
@@ -154,7 +154,7 @@
 local int unzlocal_getByte(FILE *fin,int *pi)
 {
     unsigned char c;
-        int err = fread(&c, 1, 1, fin);
+        size_t err = fread(&c, 1, 1, fin);
     if (err==1)
     {
         *pi = (int)c;
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/AboutDialog.cpp ./src/win32/AboutDialog.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/AboutDialog.cpp	2004-05-13 23:31:14 +0900
+++ ./src/win32/AboutDialog.cpp	2006-06-06 23:33:43 +0900
@@ -19,9 +19,9 @@
 // AboutDialog.cpp : implementation file
 //
 
+#include "stdafx.h"
 #include "AboutDialog.h"
 #include "../AutoBuild.h"
-#include "resource.h"
 
 #ifdef _DEBUG
 #define new DEBUG_NEW
@@ -74,10 +74,3 @@
   return TRUE;  // return TRUE unless you set the focus to a control
   // EXCEPTION: OCX Property Pages should return FALSE
 }
-
-void AboutDialog::OnOK() 
-{
-  // TODO: Add extra validation here
-  
-  CDialog::OnOK();
-}
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/AboutDialog.h ./src/win32/AboutDialog.h
--- ../VisualBoyAdvance-1.7.2/src/win32/AboutDialog.h	2004-05-13 22:48:17 +0900
+++ ./src/win32/AboutDialog.h	2006-05-27 23:47:33 +0900
@@ -60,7 +60,6 @@
   // Generated message map functions
   //{{AFX_MSG(AboutDialog)
   virtual BOOL OnInitDialog();
-  virtual void OnOK();
   //}}AFX_MSG
 
 
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/AccelEditor.cpp ./src/win32/AccelEditor.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/AccelEditor.cpp	2004-05-13 23:31:03 +0900
+++ ./src/win32/AccelEditor.cpp	2006-05-27 23:47:33 +0900
@@ -156,7 +156,7 @@
       pAccel->GetString(szBuffer);
       index = m_currents.AddString(szBuffer);
       // and a pointer to the accel object.
-      m_currents.SetItemData(index, (DWORD)pAccel);
+      m_currents.SetItemData(index, (DWORD_PTR)pAccel);
     }
   }
   // Init the key editor
@@ -185,7 +185,8 @@
     return; // no valid key, abort
 
   int count = m_commands.GetCount();
-  for (int index = 0; index < count; index++) {
+  int index;
+  for (index = 0; index < count; index++) {
 
     wIDCommand = LOWORD(m_commands.GetItemData(index));
     mgr.m_mapAccelTable.Lookup(wIDCommand, pCmdAccel);
@@ -234,7 +235,7 @@
   pAccel->GetString(szBuffer);
 
   index = m_currents.AddString(szBuffer);
-  m_currents.SetItemData(index, (DWORD)pAccel);
+  m_currents.SetItemData(index, (DWORD_PTR)pAccel);
 
   // Reset the key editor.
   m_key.ResetKey();
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/AcceleratorManager.cpp ./src/win32/AcceleratorManager.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/AcceleratorManager.cpp	2003-11-04 23:09:51 +0900
+++ ./src/win32/AcceleratorManager.cpp	2006-06-07 06:04:20 +0900
@@ -247,7 +247,7 @@
     }
   }
   
-  int nAccel = arrayACCEL.GetSize();
+  INT_PTR nAccel = arrayACCEL.GetSize();
   LPACCEL lpAccel = (LPACCEL)LocalAlloc(LPTR, nAccel * sizeof(ACCEL));
   if (!lpAccel) {
     for (iLoop = 0; iLoop < nAccel; iLoop++)
@@ -268,7 +268,7 @@
   }
   arrayACCEL.RemoveAll();
 
-  HACCEL hNewTable = CreateAcceleratorTable(lpAccel, nAccel);
+  HACCEL hNewTable = CreateAcceleratorTable(lpAccel, (int)nAccel);
   if (!hNewTable) {
     ::LocalFree(lpAccel);
     return false;
@@ -709,14 +709,14 @@
   }
   //  AccelsDatasArray.InsertAt(0, MAKELONG(65535, iCount));
   
-  int count = AccelsDatasArray.GetSize();
+  INT_PTR count = AccelsDatasArray.GetSize();
   DWORD *data = (DWORD *)malloc(count * sizeof(DWORD));
   ASSERT(data != NULL);
 
   for(int index = 0; index < count; index++)
     data[index] = AccelsDatasArray[index];
 
-  regSetBinaryValue("keyboard", (char *)data, count*sizeof(DWORD));
+  regSetBinaryValue("keyboard", (char *)data, (int)(count*sizeof(DWORD)));
 
   AccelsDatasArray.RemoveAll();
   CmdDatasArray.RemoveAll();
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/BitmapControl.h ./src/win32/BitmapControl.h
--- ../VisualBoyAdvance-1.7.2/src/win32/BitmapControl.h	2004-05-13 22:47:15 +0900
+++ ./src/win32/BitmapControl.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_BITMAPCONTROL_H__2434AADB_B6A5_4E43_AA16_7B65B6F7FA26__INCLUDED_)
 #define AFX_BITMAPCONTROL_H__2434AADB_B6A5_4E43_AA16_7B65B6F7FA26__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/BugReport.cpp ./src/win32/BugReport.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/BugReport.cpp	2004-05-13 23:29:11 +0900
+++ ./src/win32/BugReport.cpp	2006-08-02 04:21:16 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -216,7 +216,6 @@
   AppendFormat(report, "Using BIOS   : %d\r\n", theApp.useBiosFile);
   AppendFormat(report, "Skip BIOS    : %d\r\n", theApp.skipBiosFile);
   AppendFormat(report, "Disable SFX  : %d\r\n", cpuDisableSfx);
-  AppendFormat(report, "Skip intro   : %d\r\n", theApp.removeIntros);
   AppendFormat(report, "Throttle     : %d\r\n", theApp.throttle);
   AppendFormat(report, "Rewind       : %d\r\n", theApp.rewindTimer);
   AppendFormat(report, "Auto frame   : %d\r\n", theApp.autoFrameSkip);
@@ -227,6 +226,7 @@
   AppendFormat(report, "Green shift  : %08x\r\n", systemGreenShift);
   AppendFormat(report, "Blue shift   : %08x\r\n", systemBlueShift);
   AppendFormat(report, "Layer setting: %04X\r\n", layerSettings);
+  AppendFormat(report, "Mirroring    : %d\r\n", mirroringEnable);
   AppendFormat(report, "Save type    : %d (%d)\r\n", 
                theApp.winSaveType, cpuSaveType);
   AppendFormat(report, "Flash size   : %08X (%08x)\r\n", 
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/CmdAccelOb.cpp ./src/win32/CmdAccelOb.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/CmdAccelOb.cpp	2003-11-04 23:09:52 +0900
+++ ./src/win32/CmdAccelOb.cpp	2006-05-14 01:32:16 +0900
@@ -264,7 +264,8 @@
     return;
 
   // modifiers part
-  for (int i = 0; i < sizetable(mapVirtSysKeys); i++) {
+  int i;
+  for (i = 0; i < sizetable(mapVirtSysKeys); i++) {
     if (m_cVirt & mapVirtSysKeys[i].wKey) {
       szBuffer += mapVirtSysKeys[i].szKey;
       szBuffer += "+";
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ColorButton.h ./src/win32/ColorButton.h
--- ../VisualBoyAdvance-1.7.2/src/win32/ColorButton.h	2004-05-13 22:46:40 +0900
+++ ./src/win32/ColorButton.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_COLORBUTTON_H__DF02109B_B91C_49FD_954F_74A48B83C314__INCLUDED_)
 #define AFX_COLORBUTTON_H__DF02109B_B91C_49FD_954F_74A48B83C314__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ColorControl.h ./src/win32/ColorControl.h
--- ../VisualBoyAdvance-1.7.2/src/win32/ColorControl.h	2004-05-13 22:46:30 +0900
+++ ./src/win32/ColorControl.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_COLORCONTROL_H__747E1E47_DDFA_4D67_B337_A473F2BACB86__INCLUDED_)
 #define AFX_COLORCONTROL_H__747E1E47_DDFA_4D67_B337_A473F2BACB86__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Commands.cpp ./src/win32/Commands.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Commands.cpp	2004-05-13 23:28:36 +0900
+++ ./src/win32/Commands.cpp	2006-08-04 00:20:17 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -129,13 +129,13 @@
   { "OptionsEmulatorDirectories", ID_OPTIONS_EMULATOR_DIRECTORIES },
   { "OptionsEmulatorSelectBIOS", ID_OPTIONS_EMULATOR_SELECTBIOSFILE },
   { "OptionsEmulatorUseBIOS", ID_OPTIONS_EMULATOR_USEBIOSFILE },
+  { "OptionsEmulatorGameOverrides", ID_OPTIONS_EMULATOR_GAMEOVERRIDES },
   { "OptionsEmulatorSkipBIOS", ID_OPTIONS_EMULATOR_SKIPBIOS },
   { "OptionsEmulatorShowSpeedNone", ID_OPTIONS_EMULATOR_SHOWSPEED_NONE },
   { "OptionsEmulatorShowSpeedPercentage", ID_OPTIONS_EMULATOR_SHOWSPEED_PERCENTAGE },
   { "OptionsEmulatorShowSpeedDetailed", ID_OPTIONS_EMULATOR_SHOWSPEED_DETAILED },
   { "OptionsEmulatorShowSpeedTransparent", ID_OPTIONS_EMULATOR_SHOWSPEED_TRANSPARENT },
   { "OptionsEmulatorSpeedupToggle", ID_OPTIONS_EMULATOR_SPEEDUPTOGGLE },
-  { "OptionsEmulatorRemoveIntros", ID_OPTIONS_EMULATOR_REMOVEINTROSGBA },
   { "OptionsEmulatorAutoHideMenu", ID_OPTIONS_EMULATOR_AUTOHIDEMENU },
   { "OptionsEmulatorSaveAuto", ID_OPTIONS_EMULATOR_SAVETYPE_AUTOMATIC },
   { "OptionsEmulatorSaveEEPROM", ID_OPTIONS_EMULATOR_SAVETYPE_EEPROM },
@@ -147,6 +147,7 @@
   { "OptionsEmulatorAutoIPSPatch", ID_OPTIONS_EMULATOR_AUTOMATICALLYIPSPATCH },
   { "OptionsEmulatorAGBPrint", ID_OPTIONS_EMULATOR_AGBPRINT },
   { "OptionsEmulatorRTC", ID_OPTIONS_EMULATOR_REALTIMECLOCK },
+  { "OptionsEmulatorGenericflashcard", ID_OPTIONS_EMULATOR_GENERICFLASHCARD },
   { "OptionsEmulatorRewindInterval", ID_OPTIONS_EMULATOR_REWINDINTERVAL },
   { "OptionsSoundOff", ID_OPTIONS_SOUND_OFF },
   { "OptionsSoundMute", ID_OPTIONS_SOUND_MUTE },
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Direct3D.cpp ./src/win32/Direct3D.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Direct3D.cpp	2004-05-13 23:28:26 +0900
+++ ./src/win32/Direct3D.cpp	2006-08-11 19:58:39 +0900
@@ -1,6 +1,7 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
 // Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -17,11 +18,8 @@
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
 #include "stdafx.h"
-#include "vba.h"
 
-#define DIRECT3D_VERSION 0x0800
-#include <d3d8.h>
-#include <d3dx8.h>
+#include "Display.h"
 
 #include "MainWnd.h"
 
@@ -29,10 +27,17 @@
 #include "../GBA.h"
 #include "../Globals.h"
 #include "../Text.h"
+#include "../Util.h"
 #include "../gb/gbGlobals.h"
 
-#include "Reg.h"
-#include "resource.h"
+// Direct3D
+#define DIRECT3D_VERSION 0x0900
+#include <d3d9.h>      // main include file
+#include <D3dx9core.h> // required for font rednering
+#include <Dxerr.h>     // contains debug functions
+
+extern int Init_2xSaI(u32); // initializes all pixel filters
+extern int systemSpeed;
 
 #ifdef _DEBUG
 #define new DEBUG_NEW
